/* QuestCore Item Generator
 *
 * Version 1.2
 * 2/16/2021
 *
 * Function for generating ammo scripts
 *
 * ammo.c
 */

#include <stdio.h>
#include <string.h>
#include "defaults.h"
#include "color.h"

void mkammo(void)
{
	typedef struct {
		char name[32];
		char varname[24];
		char shortname[24];
		char desc[128];
		char rounds[4];
		char value[8];
	} AMMO_T;

   char o_outfile[64];

	printf("%sFile (default: %s): %s", GREEN, DEFAULT_AMMO_OUTPUT_FILE, RESET);
	fgets(o_outfile, 64, stdin);
	o_outfile[strcspn(o_outfile, "\n")] = 0;

	if (strlen(o_outfile) == 0) {
		strcpy(o_outfile, DEFAULT_AMMO_OUTPUT_FILE);
	}

	AMMO_T Ammo;
	FILE *fptr;
	fptr = fopen(o_outfile, "a");

	printf("Creating new ammo...\nWriting to file %s\n\n", o_outfile);

	printf("%sAmmo Name: %s", GREEN, RESET);
	fgets(Ammo.name, 32, stdin);
	fprintf(fptr, "@create $ammo named %s", Ammo.name);

	printf("%sGlobal Variable Name for #0: %s", GREEN, RESET);
	fgets(Ammo.varname, 24, stdin);
	Ammo.varname[strcspn(Ammo.varname, "\n")] = 0;

	char sn[4] = {Ammo.name[0], Ammo.name[1], Ammo.name[2], '\0'};
	strcpy(Ammo.shortname, sn);

	printf("%sDescription: %s", GREEN, RESET);
	fgets(Ammo.desc, 128, stdin);
	fprintf(fptr, "@desc %s as %s", Ammo.shortname, Ammo.desc);

	printf("%sRounds: %s", GREEN, RESET);
	fgets(Ammo.rounds, 8, stdin);
	fprintf(fptr, "@set %s.rounds to %s", Ammo.shortname, Ammo.rounds);

	printf("%sValue (decimal): %s", GREEN, RESET);
	fgets(Ammo.value, 8, stdin);
	fprintf(fptr, "@set %s.value_base to %s", Ammo.shortname, Ammo.value);

	fprintf(fptr, "@chmod %s rf\n", Ammo.shortname);
	fprintf(fptr, ";add_property(#0, \"%s\", max_object(), {player, \"rc\"})\n", Ammo.varname);
	fprintf(fptr, ";move($%s, $nothing)\n", Ammo.varname);

	fprintf(fptr, "\n");
	fclose(fptr);

}
