/* QuestCore Item Generator
 *
 * Version 1.2
 * 2/16/2021
 *
 * Function for generating armor scripts
 *
 * armor.c
 */

#include <stdio.h>
#include <string.h>
#include "defaults.h"
#include "color.h"

void mkarmor(void)
{
	typedef struct
	{
		char name[32];
		char varname[24];
		char shortname[24];
		char desc[128];
		char armor[8];
		char bodyarea[12];
		char value[8];
	} ARMOR_T;

	char a_outfile[64];

	printf("%sFile (default: %s): %s", GREEN, DEFAULT_ARMOR_OUTPUT_FILE, RESET);
	fgets(a_outfile, 64, stdin);
	a_outfile[strcspn(a_outfile, "\n")] = 0;

	if (strlen(a_outfile) == 0) {
		strcpy(a_outfile, DEFAULT_ARMOR_OUTPUT_FILE);
	}

	ARMOR_T Armor;
	FILE *fptr;
	fptr = fopen(a_outfile, "a");

	printf("Creating new armor...\nWriting to file %s\n\n", a_outfile);

	printf("%sArmor Name: %s", GREEN, RESET);
	fgets(Armor.name, 32, stdin);
	fprintf(fptr, "@create $clothing named %s", Armor.name);

	printf("%sGlobal Variable Name for #0: %s", GREEN, RESET);
	fgets(Armor.varname, 24, stdin);
	Armor.varname[strcspn(Armor.varname, "\n")] = 0;

	char sn[4] = {Armor.name[0], Armor.name[1], Armor.name[2], '\0'};
	strcpy(Armor.shortname, sn);

	printf("%sDescription: %s", GREEN, RESET);
	fgets(Armor.desc, 128, stdin);
	fprintf(fptr, "@desc %s as %s", Armor.shortname, Armor.desc);

	printf("%sBody Area: %s", GREEN, RESET);
	fgets(Armor.bodyarea, 8, stdin);
	Armor.bodyarea[strcspn(Armor.bodyarea, "\n")] = 0;
	fprintf(fptr, "@set %s.body_area to \"%s\"\n", Armor.shortname, Armor.bodyarea);

	printf("%sArmor (decimal): %s", GREEN, RESET);
	fgets(Armor.armor, 8, stdin);
	fprintf(fptr, "@set %s.armor to %s", Armor.shortname, Armor.armor);

	printf("%sValue (decimal): %s", GREEN, RESET);
	fgets(Armor.value, 8, stdin);
	fprintf(fptr, "@set %s.value_base to %s", Armor.shortname, Armor.value);

	fprintf(fptr, "@chmod %s rf\n", Armor.shortname);
	fprintf(fptr, ";add_property(#0, \"%s\", max_object(), {player, \"rc\"})\n", Armor.varname);
	fprintf(fptr, ";move($%s, $nothing)\n", Armor.varname);
	fprintf(fptr, "@kgen $%s\n", Armor.varname);

	fprintf(fptr, "\n");
	fclose(fptr);
}
