/* QuestCore Item Generator
 *
 * Version 1.2
 * 2/16/2021
 *
 * Function for generating food scripts
 *
 * food.c
 */

#include <stdio.h>
#include <string.h>
#include "defaults.h"
#include "color.h"

void mkfood(void)
{
	typedef struct
	{
		char name[32];
		char varname[24];
		char shortname[24];
		char desc[128];
		char units[4];
		char is_solid[1];
		char heal[8];
		char value[8];
	} FOOD_T;

	char f_outfile[64];

	printf("%sFile (default: %s): %s", GREEN, DEFAULT_FOOD_OUTPUT_FILE, RESET);
	fgets(f_outfile, 64, stdin);
	f_outfile[strcspn(f_outfile, "\n")] = 0;

	if (strlen(f_outfile) == 0) {
		strcpy(f_outfile, DEFAULT_FOOD_OUTPUT_FILE);
	}

	FOOD_T Food;
	FILE *fptr;
	fptr = fopen(f_outfile, "a");

	printf("Creating new food...\nWriting to file %s\n\n", f_outfile);

	printf("%sFood Name: %s", GREEN, RESET);
	fgets(Food.name, 32, stdin);
	fprintf(fptr, "@create $food2 named %s", Food.name);

	printf("%sGlobal Variable Name for #0: %s", GREEN, RESET);
	fgets(Food.varname, 24, stdin);
	Food.varname[strcspn(Food.varname, "\n")] = 0;

	char sn[4] = {Food.name[0], Food.name[1], Food.name[2], '\0'};
	strcpy(Food.shortname, sn);

	printf("%sDescription: %s", GREEN, RESET);
	fgets(Food.desc, 128, stdin);
	fprintf(fptr, "@desc %s as %s", Food.shortname, Food.desc);

	printf("%sUnits: %s", GREEN, RESET);
	fgets(Food.units, 8, stdin);
	fprintf(fptr, "@set %s.units to %s", Food.shortname, Food.units);

	printf("%sSolid (0 or 1): %s", GREEN, RESET);
	fgets(Food.is_solid, 8, stdin);
	fprintf(fptr, "@set %s.solid to %s", Food.shortname, Food.is_solid);

	printf("%sHeals (decimal): %s", GREEN, RESET);
	fgets(Food.heal, 8, stdin);
	fprintf(fptr, "@set %s.healing to %s", Food.shortname, Food.heal);

	printf("%sValue (decimal): %s", GREEN, RESET);
	fgets(Food.value, 8, stdin);
	fprintf(fptr, "@set %s.value_base to %s", Food.shortname, Food.value);

	fprintf(fptr, "@chmod %s rf\n", Food.shortname);
	fprintf(fptr, ";add_property(#0, \"%s\", max_object(), {player, \"rc\"})\n", Food.varname);
	fprintf(fptr, ";move($%s, $nothing)\n", Food.varname);

	fprintf(fptr, "\n");
	fclose(fptr);
}
