/* QuestCore Item Generator
 *
 * Version 1.2
 * 2/16/2021
 *
 * Main program
 *
 * main.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "defaults.h"
#include "color.h"

#define VERSION "1.2"

extern void(mkweapon(void));	/* weapon.c  */
extern void(mkammo(void));	/* ammo.c    */
extern void(mkarmor(void));	/* armor.c   */
extern void(mkfood(void));	/* food.c    */
extern void(mkmonster(void));   /* monster.c */

char entry[48];

void display_title(void)
{
	printf("%s%sQuestCore Item Generator %sversion %s%s\n", BOLD, GREEN, WHITE, VERSION, RESET);
	printf("%s____________________________________%s\n", GREEN, RESET);	
}

void menu(void)
{
	printf(" w - Create weapon\n o - Create ammo\n a - Create armor\n f - Create food\n m - Create monster\n q - Exit program\n");
}

int main(int argc, char *argv[])
{
	char itemtype[12];
	
	if (argc > 2) {
		printf("Usage: %s [weapon|ammo|armor|food|monster]\n       %s [w|o|a|f|m]\n", argv[0], argv[0]);
		exit(1);
	}
	
	if (argc == 2) {
		if (!strcmp(argv[1], "w") || !strcmp(argv[1], "weapon")) {
			strcpy(itemtype, "Weapon");
			mkweapon();
		} else if (!strcmp(argv[1], "o") || !strcmp(argv[1], "ammo")) {
			strcpy(itemtype, "Ammo");
			mkammo();
		} else if (!strcmp(argv[1], "a") || !strcmp(argv[1], "armor")) {
			strcpy(itemtype, "Armor");
			mkarmor();
		} else if (!strcmp(argv[1], "f") || !strcmp(argv[1], "food")) {
			strcpy(itemtype, "Food");
			mkfood();
		} else if (!strcmp(argv[1], "m") || !strcmp(argv[1], "monster")) {
			strcpy(itemtype, "Monster");
			mkmonster();
		} else {
			printf("%s: Invalid parameter\n", argv[0]);
			printf("Usage: %s [weapon|ammo|armor|food|monster]\n       %s [w|o|a|f|m]\n", argv[0], argv[0]);
			return(1);
		}
		printf("%s%s%s complete.%s\n", BOLD, GREEN, itemtype, RESET);
		exit(0);
	}
	
	if (argc == 1) {
		display_title();
		menu();
		prompt:
		printf("%s%s}%s ", BOLD, PURPLE, RESET);
		fgets(entry, 48, stdin);
		entry[strcspn(entry, "\n")] = 0;
		if (!strcmp(entry, "w") || !strcmp(entry, "weapon")) {
			strcpy(itemtype, "Weapon");
			mkweapon();
			printf("%s%s%s complete.%s\n", BOLD, GREEN, itemtype, RESET);
			goto prompt;
		} else if (!strcmp(entry, "o") || !strcmp(entry, "ammo")) {
			strcpy(itemtype, "Ammo");
			mkammo();
			printf("%s%s%s complete.%s\n", BOLD, GREEN, itemtype, RESET);
			goto prompt;
		} else if (!strcmp(entry, "a") || !strcmp(entry, "armor")) {
			strcpy(itemtype, "Armor");
			mkarmor();
			printf("%s%s%s complete.%s\n", BOLD, GREEN, itemtype, RESET);
			goto prompt;
		} else if (!strcmp(entry, "f") || !strcmp(entry, "food")) {
			strcpy(itemtype, "Food");
			mkfood();
			printf("%s%s%s complete.%s\n", BOLD, GREEN, itemtype, RESET);
			goto prompt;
		} else if (!strcmp(entry, "m") || !strcmp(entry, "monster")) {
			strcpy(itemtype, "Monster");
			mkmonster();
			printf("%s%s%s complete.%s\n", BOLD, GREEN, itemtype, RESET);
			goto prompt;
		} else if (!strcmp(entry, "q") || !strcmp(entry, "quit")) {
			printf("%sExiting program...%s\n", GREEN, RESET);
			exit(0);
		} else if (!strcmp(entry, "?") || !strcmp(entry, "help") || !strcmp(entry, "")) {
			menu();
			goto prompt;
		} else {
			printf("%s%sUnknown command '%s'%s\n", BOLD, RED, entry, RESET);
			goto prompt;
		}
	}
	return(0);
}
